Attribute VB_Name = "mMain"
Option Explicit

Public ErrorClass As clError

Public Sub main()
On Error GoTo HandleError
    
    Set ErrorClass = New clError
    Load frmTest
    frmTest.Show vbModal
    Set ErrorClass = Nothing
    
    Exit Sub
    
HandleError:
    If ErrorClass Is Nothing Then
        MsgBox "An error has occurred with the following description : " & Err.Description & vbCrLf & _
               "from the source : " & Err.Source & vbCrLf & _
               "with an error number of : " & Err.Number & vbCrLf & vbCrLf & _
               "This error can not be logged because the error class was not be initialised in time." & vbCrLf & _
               "The program will now shut down.", vbInformation Or vbOKOnly, App.Title
        EndProgram
    Else
        Select Case ErrorClass.LogError(Err.Description, "mMain.main (" & Err.Source & ")", Err.Number, True)
            Case ErrorRequest.Terminate
                EndProgram
            Case ErrorRequest.ResumeNext
                Resume Next
            Case ErrorRequest.Retry
                Resume
        End Select
    End If
End Sub

Public Sub EndProgram()
On Error Resume Next
    Set ErrorClass = Nothing
    Unload frmTest
    End
End Sub
